<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>
    <parent>
        <groupId>xyz.ottr.lutra</groupId>
        <version>0.6.16-SNAPSHOT</version>
        <artifactId>lutra</artifactId>
        <relativePath>../pom.xml</relativePath>
    </parent>

    <artifactId>lutra-stottr</artifactId>
    <packaging>jar</packaging>

    <name>${project.groupId}:${project.artifactId}</name>
    <description>
        This Lutra submodule implements readers and writers for the stOTTR formalisation format (https://spec.ottr.xyz/stOTTR/).
        stOTTR is a custom-built serialisation format for OTTR intended to be easy to read and write for humans (and computers!).

        Lutra is the reference implementation of the OTTR framework. For more information about OTTR, see http://ottr.xyz.
    </description>

    <properties>
        <stottr.version>0.1.3</stottr.version>
        <url.stottrspec>https://spec.ottr.xyz/stOTTR/${stottr.version}/</url.stottrspec>
        <!--url.stottrspec>https://dev.spec.ottr.xyz/stOTTR/</url.stottrspec-->
        <local.stottrspec>${project.basedir}/src/main/antlr4/</local.stottrspec>
    </properties>

    <dependencies>
        <dependency>
            <groupId>${project.groupId}</groupId>
            <artifactId>lutra-core</artifactId>
            <!-- for transitive dependencies see module POM -->
        </dependency>
        <dependency>
            <groupId>${project.groupId}</groupId>
            <artifactId>lutra-wottr</artifactId>
            <!-- for transitive dependencies see module POM -->
        </dependency>

        <dependency>
            <groupId>org.antlr</groupId>
            <artifactId>antlr4-runtime</artifactId>
            <!-- for transitive dependencies see module POM -->
        </dependency>
    </dependencies>

    <build>
        <plugins>

            <plugin>
                <groupId>com.googlecode.maven-download-plugin</groupId>
                <artifactId>download-maven-plugin</artifactId>
                <executions>
                    <execution>
                        <id>download-stottr</id>
                        <phase>generate-sources</phase>
                        <goals>
                            <goal>wget</goal>
                        </goals>
                        <configuration>
                            <url>${url.stottrspec}stOTTR.g4</url>
                            <skipCache>false</skipCache>
                            <overwrite>true</overwrite>
                            <outputDirectory>${local.stottrspec}xyz/ottr/lutra/stottr/antlr/</outputDirectory>
                        </configuration>
                    </execution>
                    <execution>
                        <id>download-stottr-dep</id>
                        <phase>generate-sources</phase>
                        <goals>
                            <goal>wget</goal>
                        </goals>
                        <configuration>
                            <url>${url.stottrspec}Turtle.g4</url>
                            <skipCache>false</skipCache>
                            <overwrite>true</overwrite>
                            <outputDirectory>${local.stottrspec}imports/</outputDirectory>
                        </configuration>
                    </execution>
                </executions>
            </plugin>
            <plugin>
                <groupId>org.antlr</groupId>
                <artifactId>antlr4-maven-plugin</artifactId>
                <configuration>
                    <arguments>
                        <argument>-visitor</argument>
                    </arguments>
                </configuration>
                <executions>
                    <execution>
                        <id>antlr</id>
                        <goals>
                            <goal>antlr4</goal>
                        </goals>
                    </execution>
                </executions>
            </plugin>

            <plugin>
                <artifactId>plantuml-generator-maven-plugin</artifactId>
                <groupId>de.elnarion.maven</groupId>
                <executions>
                    <execution>
                        <id>lutra.stottr</id>
                        <goals>
                            <goal>generate</goal>
                        </goals>
                        <phase>generate-test-sources</phase>
                        <configuration>
                            <outputFilename>stottr_all.puml</outputFilename>
                            <hideFields>true</hideFields>
                            <hideMethods>true</hideMethods>
                            <scanPackages>
                                <scanPackage>
                                    xyz.ottr.lutra.stottr
                                </scanPackage>
                            </scanPackages>
                        </configuration>
                    </execution>
                    <execution>
                        <id>lutra.stottr.parser</id>
                        <goals>
                            <goal>generate</goal>
                        </goals>
                        <phase>generate-test-sources</phase>
                        <configuration>
                            <outputFilename>stottr-parser.puml</outputFilename>
                            <hideFields>true</hideFields>
                            <hideMethods>true</hideMethods>
                            <scanPackages>
                                <scanPackage>
                                    xyz.ottr.lutra.stottr.parser
                                </scanPackage>
                            </scanPackages>
                        </configuration>
                    </execution>
                    <execution>
                        <id>lutra.stottr.writer</id>
                        <goals>
                            <goal>generate</goal>
                        </goals>
                        <phase>generate-test-sources</phase>
                        <configuration>
                            <outputFilename>stottr-writer.puml</outputFilename>
                            <hideFields>true</hideFields>
                            <hideMethods>true</hideMethods>
                            <scanPackages>
                                <scanPackage>
                                    xyz.ottr.lutra.stottr.writer
                                </scanPackage>
                            </scanPackages>
                        </configuration>
                    </execution>
                </executions>
            </plugin>
        </plugins>
    </build>
</project>
